2500

How would I validate that a program exists, in a way that will either return an error and exit, or continue with the script?

It seems like it should be easy, but it's been stumping me.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
gregh
  • 30,059
  • 8
  • 27
  • 26
  • What is a "program"? Does it include functions and aliases? `which` returns true for these. `type` without arguments will additionally return true for reserved words and shell builtins. If "program" means "excutable in `$PATH`", then see [this answer](https://stackoverflow.com/a/53798785/5353461). – Tom Hale Dec 16 '18 at 02:12
  • Also relevant is [How to 'hash -r' and refresh all shells?](https://unix.stackexchange.com/q/398028/56041) and [When to rehash executables in $PATH with bash?](https://superuser.com/q/999439/173513) – jww Jan 30 '19 at 05:10

39 Answers39

3500

Answer

POSIX compatible:

command -v <the_command>

Example use:

if ! command -v COMMAND &> /dev/null
then
    echo "COMMAND could not be found"
    exit
fi

For Bash specific environments:

hash <the_command> # For regular commands. Or...
type <the_command> # To check built-ins and keywords

Explanation

Avoid which. Not only is it an external process you're launching for doing very little (meaning builtins like hash, type or command are way cheaper), you can also rely on the builtins to actually do what you want, while the effects of external commands can easily vary from system to system.

Why care?

  • Many operating systems have a which that doesn't even set an exit status, meaning the if which foo won't even work there and will always report that foo exists, even if it doesn't (note that some POSIX shells appear to do this for hash too).
  • Many operating systems make which do custom and evil stuff like change the output or even hook into the package manager.

So, don't use which. Instead use one of these:

$ command -v foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }
$ type foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }
$ hash foo 2>/dev/null || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }

(Minor side-note: some will suggest 2>&- is the same 2>/dev/null but shorter – this is untrue. 2>&- closes FD 2 which causes an error in the program when it tries to write to stderr, which is very different from successfully writing to it and discarding the output (and dangerous!))

If your hash bang is /bin/sh then you should care about what POSIX says. type and hash's exit codes aren't terribly well defined by POSIX, and hash is seen to exit successfully when the command doesn't exist (haven't seen this with type yet). command's exit status is well defined by POSIX, so that one is probably the safest to use.

If your script uses bash though, POSIX rules don't really matter anymore and both type and hash become perfectly safe to use. type now has a -P to search just the PATH and hash has the side-effect that the command's location will be hashed (for faster lookup next time you use it), which is usually a good thing since you probably check for its existence in order to actually use it.

As a simple example, here's a function that runs gdate if it exists, otherwise date:

gnudate() {
    if hash gdate 2>/dev/null; then
        gdate "$@"
    else
        date "$@"
    fi
}

Alternative with a complete feature set

You can use scripts-common to reach your need.

To check if something is installed, you can do:

checkBin <the_command> || errorMessage "This tool requires <the_command>. Install it please, and then run this tool again."
birgersp
  • 2,907
  • 4
  • 25
  • 53
lhunath
  • 103,030
  • 16
  • 63
  • 74
  • Would you mind to explain what the `&>/dev/null` and `>&2` parts are for? The line seems to work fine without them too. Thanks. – Geert Jul 16 '10 at 05:54
  • 39
    @Geert: The &>/dev/null part hides the message 'type' emits when 'foo' doesn't exist. The >&2 on the echo makes sure to send the error message to standard error instead of standard output; because that's convention. They both appear on your terminal, but standard error is definitely the preferred output for error messages and unexpected warnings. – lhunath Jul 19 '10 at 13:43
  • 6
    the -P flag does not work in 'sh', eg http://stackoverflow.com/questions/2608688/check-if-a-program-exists-in-bash – momeara Apr 01 '11 at 19:18
  • 136
    For those unfamiliar with 'advanced' i/o redirection in bash: 1) `2>&-` *("close output file descriptor 2", which is stderr)* has the same result as `2> /dev/null`; 2) `>&2` is a shortcut for `1>&2`, which you may recognize as "redirect stdout to stderr". See the [Advanced Bash Scripting Guide i/o redirection page](http://tldp.org/LDP/abs/html/io-redirection.html) for more info. – mikewaters Dec 21 '11 at 19:48
  • Btw, there are allot of programs that don't support "-v" (git for instance), it's a safer bet to use "--version". – rogeriopvl Mar 06 '12 at 20:11
  • 3
    If `command` is safest to use with the POSIX constraint, why should I use `type` or `hash` even if I was using bash? – michuelnik Aug 30 '12 at 08:53
  • 2
    @michuelnik I explain how `hash` causes the command name to be added to the hash table and `type` has options to do things `command` can't. All-in-all it's a matter of preference, the `type` and `hash` solutions are a bit shorter. Also, don't confuse `bash` and `sh` -- there is zero gain from using POSIX syntax when your interpreter is bash. You gain no portability at all. Your hashbang is `bash` and you will always require it. You might as well use normal `bash` syntax. Just like it makes little sense to limit yourself to C syntax when you're compiling with a C++ compiler anyway. – lhunath Aug 31 '12 at 09:08
  • 1
    hash doesnt work on minix's default shell. command -v doesnt work on minix's default shell. (minix 3) – don bright Jun 09 '13 at 03:04
  • 2
    @mikewaters I don't think it's very responsible to link to LDP's ABS. It is broadly accepted by bash experts to be a bad influence for bash students. Instead, I would propose the following to learn about I/O in bash: http://mywiki.wooledge.org/BashSheet#Streams – lhunath Jun 10 '13 at 13:26
  • 10
    @mikewaters The ABS looks fairly advanced and describes a wide range of bash and non-bash CLI functionality, but it is very negligent in many aspects and does not follow good practice. I don't have nearly enough space in this comment to do a write-up; but I can paste a few random examples of BAD code: `while read element ; do .. done <<< $(echo ${ArrayVar[*]})`, `for word in $(fgrep -l $ORIGINAL *.txt)`, `ls -l "$directory" | sed 1d `, {{for a in `seq $BEGIN $END`}}, ... Many have tried to contact the authors and propose improvements but it's no wiki and requests have landed on deaf ears. – lhunath Jun 12 '13 at 20:00
  • 2
    @lhunath thanks. I tried to edit my comment no luck - too old. catonmat has a good pdf at http://www.catonmat.net/download/bash-redirections-cheat-sheet.pdf – mikewaters Jun 13 '13 at 14:25
  • 1
    Can someone explain to me in very simple terms the purpose of the curly braces to print the failure message in this construct: `$ command -v foo >/dev/null 2>&1 || { echo >&2 "I require foo but it's not installed. Aborting."; exit 1; }` ? I ask because at least in the simple case, this will print the error message: `$ command -v foo >/dev/null 2>&1 || echo "I require foo but it's not installed. Aborting."`. Is the curly braces helpful for printing to `STDERR`? – blong May 20 '14 at 18:53
  • 2
    @CMCDragonkai In that case, you normally wouldn't do a test at all and just run the command. You can prefix a command with ! (and a space) to negate its exit status, or you can replace `||` with `&&`. See `man bash` or http://mywiki.wooledge.org/BashGuide/TestsAndConditionals#Control_Operators_.28.26.26_and_.7C.7C.29 – lhunath May 21 '14 at 02:47
  • 3
    @b.long The curly braces serve to combine the `echo` and `exit` commands so that they're both run as a result of `command`'s exit code. If you leave out the curly braces, only the `echo` command will run conditionally and the `exit` command will always run, whether the command exists or not. See http://mywiki.wooledge.org/BashGuide/TestsAndConditionals#Grouping_Statements – lhunath May 21 '14 at 02:50
  • 1
    ```command``` on fish shell doesn't support the ```-v``` option. – David Da Silva Contín Jul 03 '14 at 10:29
  • @DavidDaSilvaContín Useful to know, though note that fish is not a POSIX shell either. `command -v` also doesn't work in `cmd.exe`. – lhunath Jul 04 '14 at 12:56
  • 1
    Note that: "command -v" fails on aliases.And "which" works: command -v ls ==> alias ls='ls --group-directories-first'. And: which ls ==> /bin/ls. –  Aug 05 '14 at 06:31
  • 1
    @bize you've shown that "which" does NOT work. since it INCORRECTLY tells you /bin/ls which is NOT what the ls command on the prompt will invoke. it will invoke the `ls --group-directories first` command. so `command -v` reports correctly. Consider `alias cp=ls`, now does `command -v` or `which` report the correct thing? – lhunath Aug 06 '14 at 20:37
  • 2
    @lhunah the title of this page asks: "How to check if a program exists from a bash script?", the only real way to do so is to test for existence of a file, something like: [ -e /bin/ls ], so: you need the correct location of the file not an abstract word (ls). Much less the additional options. Besides, if you change the ls program to something like /bin/ls-temp, the "command -v ls" still reports the same, while "which" does indeed reports "null" (empty). –  Aug 08 '14 at 14:46
  • 62
    @mikewaters `2>&-` is **not** the same as `2>/dev/null`. The former closes the file descriptor, while the latter simply redirects it to `/dev/null`. You may not see an error because the program tries to inform you on stderr that stderr is closed. – nyuszika7h Nov 05 '14 at 14:36
  • 6
    None of `type`, `command -v` or `hash` are guaranteed to be present in a POSIX.1-2004 compliant shell. See http://stackoverflow.com/q/34572700/1175080 and http://stackoverflow.com/q/34572886/1175080. – Lone Learner Jan 03 '16 at 03:33
  • 3
    It might be worth noting that `which foo`, if it exists, is likely to yield failure if `foo` is a shell alias, builtin or function, whereas the above POSIX alternatives woulds yield success. Thus e.g. `which foo && foo` is closer to just plain `command foo` than `command -v foo >/dev/null 2>&1 && foo`. – kojiro Jan 25 '16 at 13:39
  • Do you have a specific example about what "custom and evil suff" `which` may do? Would it give wrong answer or just be less efficient than a buit-in command? How would it change the output? – jarno Jan 31 '16 at 12:10
  • Why `>/dev/null 2>&1` and not simply `&>/dev/null`? – user137369 Mar 02 '16 at 13:36
  • Whereas the 'hash test' seems to usually work, I've run into one case where it does not. I'm testing for the `groupadd` command (used by CentOS, for instance, whereas Ubuntu uses `addgroup`). This command lives in `/usr/sbin` and can only be invoked as `sudo`. `$ groupadd --version` yields `bash: /usr/sbin/groupadd: Permission denied`, `$ hash groupadd` yields `bash: hash: groupadd: not found`,and `$ sudo hash groupadd` yields `sudo: hash: command not found`. How to fix this? – Urhixidur Jun 09 '16 at 15:38
  • @Urhixidur Note that `hash` will only look in `PATH`. If your user's `PATH` does not include `sbin`, `hash` will not find the binary that lives there. If you want to run `bash` code with `sudo`, you need to invoke `bash` from `sudo`: `if sudo bash -c 'hash groupadd'; then ...` – lhunath Jun 10 '16 at 16:19
  • 3
    I have an efficiency comparison of all these approaches: https://www.topbug.net/blog/2016/10/11/speed-test-check-the-existence-of-a-command-in-bash-and-zsh/ – xuhdev Oct 11 '16 at 06:58
  • you need ';' inside of the { } like : { echo "failed"; } – Mike Q Aug 14 '17 at 20:14
  • It's wrong to say avoid which, unless you mean avoid it for portability. If you know you are running always on an OS that it works, then it works without all the hacky solutions we have to list up. – uchuugaka Aug 16 '17 at 00:42
  • Not to say these are bad solutions, but which works perfectly well on macOS for this use case to say "is this visible in the current PATH?" – uchuugaka Aug 16 '17 at 00:43
  • 2
    The alternatives are not hacks. The alternatives are 100% good and portable, there is not a single advantage gained by `which` and there are many downsides. `which` does NOT in fact tell you what your shell will do when you run a command. `which` is a lie. Only your shell can tell you what a command name resolves to in that shell. Only a shell builtin can provide the information you need. Stop being the poison that is spreading misinformation. – lhunath Aug 17 '17 at 01:43
  • Where do I find the docs for `command`? Googling for it doesn't seem to be working for me. – mkobit Oct 11 '17 at 16:06
  • 2
    @mkobit The documentation for Bash is in `man bash`. A short summary can be obtained using `help command` – lhunath Oct 12 '17 at 17:35
  • 1
    How come you don't even mention `test -x` which is in POSIX 2008. – user157251 Nov 13 '17 at 03:04
  • 2
    @EvanCarroll `test -x` can only tell you whether a file is executable. That requires that you already know the exact path to the file. If you have full knowledge of the one and only path to the file of your program, you could use `test`, but it's not very useful in answering the question "can I execute a command that will run a program", for that, you need to perform a command name resolution or PATH search, which test does not do. – lhunath Nov 14 '17 at 03:30
  • The only problem with this approach is, on a lot of systems "command" itself is not found (like on mine - there is no type OR command OR hash commands already present). So how do you check the existence of a 'command' which is used to test the existence of other commands? – Piyush Soni Dec 19 '17 at 06:38
  • Please note that `command` and `type` and `hash` are not external programs. They are shell built-ins. They resolve the program that the SHELL itself would run, using the internal shell logic, which is exactly what you want. Please clarify what you mean with "a lot of systems "command" itself is not found", because that's just a very misleading statement to make for the readers here. – lhunath Dec 20 '17 at 20:35
  • Actually, I just find out one pro for `which` against `c/t/h` with Ubuntu and GNU make. This last tool has a small bug because of an [optimization](https://stackoverflow.com/questions/17547625/how-to-use-shell-builtin-function-from-a-makefile#17550243) and will not always execute builtins. Because `which` is an executable on Ubuntu, `$(shell which cmd)` will work and `$(shell command -v cmd)` will not. Same thing for execution lines in rules. – calandoa Apr 12 '18 at 14:15
  • Very nice, `command -v` is also applicable on Mac OS X Darwin – Jeroen Bouman Oct 18 '18 at 09:31
  • Great answer! The only thing I can add is perhaps exiting with an exit code of `127` instead of the catchall `1` exit code. See: http://www.tldp.org/LDP/abs/html/exitcodes.html – Housni Oct 24 '18 at 17:29
  • 1
    @lhunath In your example `command -v foo >/dev/null 2>&1 ...`, is there any reason you are redirecting stderr to stdout? `command -v foo` does not send anything to stderr, regardless of whether or not `foo` is a command. – Harold Fischer Feb 14 '19 at 04:54
  • Note: despite the 'command' label in 'command -v', and the usage of 'command ' invoking an actual executable (and not a bash function or alias), 'command -v' reports bash functions as well as actual 'command's. – Brian Chrisman Aug 19 '19 at 18:38
  • @HaroldFischer I also [wondered](https://github.com/bminor/bash/blob/d233b485e83c3a784b803fb894280773f16f2deb/findcmd.c). I suppose `command -v` might write to stderr if it encounters a serious error, for example an I/O error with one of the PATHs. It will definitely error if you pass `-foo` instead of `foo`, although that can be avoided with `command -v -- -foo` – joeytwiddle Oct 16 '19 at 07:15
  • 1
    The answer should include an example of how to use the commands in a script. – birgersp Jul 01 '20 at 07:02
  • @LoneLearner [`hash` is now defined by POSIX](https://pubs.opengroup.org/onlinepubs/9699919799/utilities/hash.html) – Tom Hale Aug 30 '20 at 16:39
  • In POSIX sh, &> is undefined https://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_07_02 – Cirelli94 May 26 '21 at 14:48
653

The following is a portable way to check whether a command exists in $PATH and is executable:

[ -x "$(command -v foo)" ]

Example:

if ! [ -x "$(command -v git)" ]; then
  echo 'Error: git is not installed.' >&2
  exit 1
fi

The executable check is needed because bash returns a non-executable file if no executable file with that name is found in $PATH.

Also note that if a non-executable file with the same name as the executable exists earlier in $PATH, dash returns the former, even though the latter would be executed. This is a bug and is in violation of the POSIX standard. [Bug report] [Standard]

In addition, this will fail if the command you are looking for has been defined as an alias.

nyuszika7h
  • 12,020
  • 5
  • 40
  • 49
  • unfortunately this fails on older bash 3.2 – uchuugaka Aug 16 '17 at 00:38
  • 4
    Will `command -v` produce a path even for a non-executable file? That is, the -x really necessary? – einpoklum Oct 26 '17 at 10:14
  • 5
    @einpoklum `-x` tests that the file is executable, which is what the question was. – Ken Sharp Oct 26 '17 at 13:03
  • 3
    @KenSharp: But that seems to be redundant, since `command` will itself test for its being executable - won't it? – einpoklum Oct 26 '17 at 13:04
  • 14
    @einpoklum Yes, it is necessary. In fact, even this solution may break in one edge case. Thanks for bringing this to my attention. dash, bash, and zsh all skip over non-executable files in `$PATH` when executing a command. However, the behavior of `command -v` is very inconsistent. In dash, it returns the first matching file in `$PATH`, regardless of whether it's executable or not. In bash, it returns the first executable match in `$PATH`, but if there's none, it can return a non-executable file. And in zsh, it will never return a non-executable file. – nyuszika7h Oct 26 '17 at 13:52
  • And this is true even in the shells' POSIX sh emulation mode. – nyuszika7h Oct 26 '17 at 13:55
  • 6
    As far as I can tell, `dash` is the only one out of those three that's non-POSIX-compliant; `[ -x "$(command -v COMMANDNAME)"]` will work in the other two. Looks like this bug has already been reported but hasn't got any responses yet: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=874264 – nyuszika7h Oct 26 '17 at 14:12
  • 1
    @nyuszika7h I'm using bash, and I don't see it returning a non-executable file. https://unix.stackexchange.com/q/404144/3285 – user157251 Nov 13 '17 at 03:10
  • 3
    @nyuszika7h it's important to note that if the command you wanna check for is *not* an executable, but a shell function or builtin, this solution will break. It should be used exclusively to check for executables. – Luiz Berti Dec 24 '18 at 17:07
  • Nice snipped allowing to check if a program is installed or not on one line with a basic please install reaction: `[[ ! -x "$(command -v perl)" ]] && echo "perl required, install with \"sudo apt install -y perl\"" && exit 1`. – ManuelTS May 22 '19 at 08:08
  • Futher information about "-x" on "if" statement: https://askubuntu.com/a/445473/134723 =D – Eduardo Lucio May 22 '19 at 13:22
  • I have a feeling that `-x` fails on symlinks. Is that true? https://stackoverflow.com/a/40944801/2470337 – Dr_Zaszuś Jul 03 '20 at 14:19
  • @Dr_Zaszuś Nope, that's wrong, I just tested it and it works fine on symlinks. – nyuszika7h Jul 03 '20 at 22:31
216

I agree with lhunath to discourage use of which, and his solution is perfectly valid for Bash users. However, to be more portable, command -v shall be used instead:

$ command -v foo >/dev/null 2>&1 || { echo "I require foo but it's not installed.  Aborting." >&2; exit 1; }

Command command is POSIX compliant. See here for its specification: command - execute a simple command

Note: type is POSIX compliant, but type -P is not.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
GregV
  • 2,337
  • 1
  • 12
  • 7
  • 3
    Same as above - `exit 1;` kills an xterm, if invoked from there. – user unknown Feb 18 '12 at 17:14
  • 1
    This wouldn't work on a standard sh: you &> isn't a valid redirect instructions. – jyavenard Mar 04 '12 at 11:19
  • 7
    @jyavenard: The question is tagged _bash_, hence the more concise bash-specific redirect notation `&>/dev/null`. However, I agree with you, what really matters is portability, I've edited my answer accordingly, now using standard sh redirect `>/dev/null 2>&1`. – GregV Mar 05 '12 at 10:58
  • to even improve more this answer I would do two things: 1: use "&>" to simplify it, like Josh's answer. 2: break the { } into an extra line, putting a tab before the echo, for readability – knocte May 21 '16 at 13:06
  • I just put this one liner into a bash function if anyone wants it... https://github.com/equant/my_bash_tools/blob/master/tarp.bash – equant Sep 29 '17 at 19:26
  • Fails on builtins and reserved words: Try this with the word `then` for instance. See [this answer](https://stackoverflow.com/a/53798785/5353461) if you require the executable to exist in `$PATH`. – Tom Hale Dec 16 '18 at 02:13
95

I have a function defined in my .bashrc that makes this easier.

command_exists () {
    type "$1" &> /dev/null ;
}

Here's an example of how it's used (from my .bash_profile.)

if command_exists mvim ; then
    export VISUAL="mvim --nofork"
fi
Josh Strater
  • 1,055
  • 7
  • 4
  • What does the `&>` do? – Saad Malik Apr 18 '16 at 19:51
  • 8
    The `&>` [redirects both stdout and stderr](http://www.gnu.org/software/bash/manual/bash.html#Redirecting-Standard-Output-and-Standard-Error) together. – Josh Strater Apr 26 '16 at 22:49
  • `&>` may not be available in your version of Bash. Marcello's code should work fine; it does the same thing. – Josh Strater Aug 02 '16 at 01:28
  • 3
    Fails on builtins and reserved words: Try this with the word `then` for instance. See [this answer](https://stackoverflow.com/a/53798785/5353461) if you require the executable to exist in `$PATH`. – Tom Hale Dec 16 '18 at 02:14
89

It depends on whether you want to know whether it exists in one of the directories in the $PATH variable or whether you know the absolute location of it. If you want to know if it is in the $PATH variable, use

if which programname >/dev/null; then
    echo exists
else
    echo does not exist
fi

otherwise use

if [ -x /path/to/programname ]; then
    echo exists
else
    echo does not exist
fi

The redirection to /dev/null/ in the first example suppresses the output of the which program.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
dreamlax
  • 89,489
  • 28
  • 156
  • 207
40

Expanding on @lhunath's and @GregV's answers, here's the code for the people who want to easily put that check inside an if statement:

exists()
{
  command -v "$1" >/dev/null 2>&1
}

Here's how to use it:

if exists bash; then
  echo 'Bash exists!'
else
  echo 'Your system does not have Bash'
fi
Romário
  • 1,234
  • 1
  • 16
  • 27
  • 13
    Willingness to learn and improve must be rewarded. +1 This is clean and simple. The only thing I can add is that `command` succeeds even for aliases, which might be somewhat counterintuitive. Checking for existence in an interactive shell will give different results from when you move it to a script. – Palec Dec 12 '15 at 09:23
  • 1
    I just tested and using `shopt -u expand_aliases` ignores/hides aliases (like the `alias ls='ls -F'` mentioned in another answer) and `shopt -s expand_aliases` resolves them via `command -v`. So perhaps it should be set prior to the check and unset after, though it could affect the function return value if you don't capture and return the output of the command call explicitly. – dragon788 Jul 02 '17 at 03:13
  • Why does this not work on `if exists conda; then`, even though anaconda is installed and returns: `usage: conda [-h] [-V] command...` when one enters `conda` in the terminal? (Note I verified your answer works with `if exists bash; then` on an Ubuntu 20 OS.) – a.t. Oct 17 '20 at 17:59
  • 1
    @a.t. `which conda` – Romário May 27 '21 at 18:47
24

Try using:

test -x filename

or

[ -x filename ]

From the Bash manpage under Conditional Expressions:

 -x file
          True if file exists and is executable.
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
dmckee --- ex-moderator kitten
  • 90,531
  • 23
  • 129
  • 225
18

To use hash, as @lhunath suggests, in a Bash script:

hash foo &> /dev/null
if [ $? -eq 1 ]; then
    echo >&2 "foo not found."
fi

This script runs hash and then checks if the exit code of the most recent command, the value stored in $?, is equal to 1. If hash doesn't find foo, the exit code will be 1. If foo is present, the exit code will be 0.

&> /dev/null redirects standard error and standard output from hash so that it doesn't appear onscreen and echo >&2 writes the message to standard error.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
dcharles
  • 4,602
  • 1
  • 28
  • 29
10

If you check for program existence, you are probably going to run it later anyway. Why not try to run it in the first place?

if foo --version >/dev/null 2>&1; then
    echo Found
else
    echo Not found
fi

It's a more trustworthy check that the program runs than merely looking at PATH directories and file permissions.

Plus you can get some useful result from your program, such as its version.

Of course the drawbacks are that some programs can be heavy to start and some don't have a --version option to immediately (and successfully) exit.

0xF
  • 2,059
  • 1
  • 18
  • 22
9

I never did get the previous answers to work on the box I have access to. For one, type has been installed (doing what more does). So the builtin directive is needed. This command works for me:

if [ `builtin type -p vim` ]; then echo "TRUE"; else echo "FALSE"; fi
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
Magnus
  • 19,360
  • 1
  • 25
  • 24
  • 4
    The brackets are not part of the `if` syntax, simply use `if builtin type -p vim; then ...`. And the backticks are really ancient and deprecated syntax, `$()` is supported even by `sh` on all modern systems. – nyuszika7h Feb 02 '17 at 14:42
9

Check for multiple dependencies and inform status to end users

for cmd in latex pandoc; do
  printf '%-10s' "$cmd"
  if hash "$cmd" 2>/dev/null; then
    echo OK
  else
    echo missing
  fi
done

Sample output:

latex     OK
pandoc    missing

Adjust the 10 to the maximum command length. It is not automatic, because I don't see a non-verbose POSIX way to do it: How can I align the columns of a space separated table in Bash?

Check if some apt packages are installed with dpkg -s and install them otherwise.

See: Check if an apt-get package is installed and then install it if it's not on Linux

It was previously mentioned at: How can I check if a program exists from a Bash script?

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
  • 1
    Non-verbose way to do it: 1) get rid of the width specifier; 2) add a space after your command name's printf; 3) pipe your for loop to `column -t` (part of util-linux). – Patrice Levesque Feb 22 '15 at 18:15
9

Command -v works fine if the POSIX_BUILTINS option is set for the <command> to test for, but it can fail if not. (It has worked for me for years, but I recently ran into one where it didn't work.)

I find the following to be more failproof:

test -x "$(which <command>)"

Since it tests for three things: path, existence and execution permission.

AnthonyC
  • 1,443
  • 1
  • 15
  • 22
  • Doesn't work. `test -x $(which ls)` returns 0, as does `test -x $(which sudo)`, even though `ls` is installed and runnable and `sudo` is not even installed within the docker container I'm running in. – algal Feb 20 '19 at 02:26
  • 1
    @algal You need to use quotes I think, so `test -x "$(which )"` – JoniVR Apr 02 '19 at 12:19
  • @algal Perhaps `ls` is aliased? I dont think it would work if the command has parameter. – AnthonyC Apr 02 '19 at 15:38
  • I can't vouch for this answer, but I'd also recommend quotes. `$ test -x $(which absent_cmd)` returns `test: too many arguments`, while `test -x "$(which absent_cmd)"` is properly parsed and results in exit code 1. – protoboolean Dec 17 '20 at 18:13
8

There are a ton of options here, but I was surprised no quick one-liners. This is what I used at the beginning of my scripts:

[[ "$(command -v mvn)" ]] || { echo "mvn is not installed" 1>&2 ; exit 1; }
[[ "$(command -v java)" ]] || { echo "java is not installed" 1>&2 ; exit 1; }

This is based on the selected answer here and another source.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
keisar
  • 5,026
  • 5
  • 24
  • 26
7

hash foo 2>/dev/null: works with Z shell (Zsh), Bash, Dash and ash.

type -p foo: it appears to work with Z shell, Bash and ash (BusyBox), but not Dash (it interprets -p as an argument).

command -v foo: works with Z shell, Bash, Dash, but not ash (BusyBox) (-ash: command: not found).

Also note that builtin is not available with ash and Dash.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
blueyed
  • 24,971
  • 4
  • 72
  • 70
  • Great list. From which versions? On my system `command -v foo` works on `busybox sh` (BusyBox v1.22.1 (Debian 1:1.22.0-19+b3) built-in shell (ash)). It fails correctly with 127 when foo is not found and prints the path if it finds it. – simohe Oct 05 '20 at 15:06
5

Use Bash builtins if you can:

which programname

...

type -P programname
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
4

For those interested, none of the methodologies in previous answers work if you wish to detect an installed library. I imagine you are left either with physically checking the path (potentially for header files and such), or something like this (if you are on a Debian-based distribution):

dpkg --status libdb-dev | grep -q not-installed

if [ $? -eq 0 ]; then
    apt-get install libdb-dev
fi

As you can see from the above, a "0" answer from the query means the package is not installed. This is a function of "grep" - a "0" means a match was found, a "1" means no match was found.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
Nathan Crause
  • 699
  • 6
  • 7
3

This will tell according to the location if the program exist or not:

    if [ -x /usr/bin/yum ]; then
        echo "This is Centos"
    fi
Adrien
  • 1,838
  • 1
  • 15
  • 34
Klevin Kona
  • 335
  • 1
  • 2
  • 13
2

I'd say there isn't any portable and 100% reliable way due to dangling aliases. For example:

alias john='ls --color'
alias paul='george -F'
alias george='ls -h'
alias ringo=/

Of course, only the last one is problematic (no offence to Ringo!). But all of them are valid aliases from the point of view of command -v.

In order to reject dangling ones like ringo, we have to parse the output of the shell built-in alias command and recurse into them (command -v isn't a superior to alias here.) There isn't any portable solution for it, and even a Bash-specific solution is rather tedious.

Note that a solution like this will unconditionally reject alias ls='ls -F':

test() { command -v $1 | grep -qv alias }
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
nodakai
  • 6,891
  • 3
  • 24
  • 51
  • Good point. However, when run from inside a bash script, aliases are not visible. – Basil Musa Mar 23 '16 at 16:08
  • 1
    There's also a problem, it will return false when the command 'alias' is checked. When it should return true. Example: test "alias" – Basil Musa Mar 23 '16 at 16:12
  • 2
    I just tested and using `shopt -u expand_aliases` ignores/hides these aliases and `shopt -s expand_aliases` shows them via `command -v`. – dragon788 Jul 02 '17 at 03:07
2

I wanted the same question answered but to run within a Makefile.

install:
    @if [[ ! -x "$(shell command -v ghead)" ]]; then \
        echo 'ghead does not exist. Please install it.'; \
        exit -1; \
    fi
Richard A Quadling
  • 2,944
  • 23
  • 35
2

It could be simpler, just:

#!/usr/bin/env bash                                                                
set -x                                                                             

# if local program 'foo' returns 1 (doesn't exist) then...                                                                               
if ! type -P foo; then                                                             
    echo 'crap, no foo'                                                            
else                                                                               
    echo 'sweet, we have foo!'                                                    
fi                                                                                 

Change foo to vi to get the other condition to fire.

todd_dsm
  • 672
  • 1
  • 10
  • 19
1

My setup for a Debian server:

I had the problem when multiple packages contained the same name.

For example apache2. So this was my solution:

function _apt_install() {
    apt-get install -y $1 > /dev/null
}

function _apt_install_norecommends() {
    apt-get install -y --no-install-recommends $1 > /dev/null
}
function _apt_available() {
    if [ `apt-cache search $1 | grep -o "$1" | uniq | wc -l` = "1" ]; then
        echo "Package is available : $1"
        PACKAGE_INSTALL="1"
    else
        echo "Package $1 is NOT available for install"
        echo  "We can not continue without this package..."
        echo  "Exitting now.."
        exit 0
    fi
}
function _package_install {
    _apt_available $1
    if [ "${PACKAGE_INSTALL}" = "1" ]; then
        if [ "$(dpkg-query -l $1 | tail -n1 | cut -c1-2)" = "ii" ]; then
             echo  "package is already_installed: $1"
        else
            echo  "installing package : $1, please wait.."
            _apt_install $1
            sleep 0.5
        fi
    fi
}

function _package_install_no_recommends {
    _apt_available $1
    if [ "${PACKAGE_INSTALL}" = "1" ]; then
        if [ "$(dpkg-query -l $1 | tail -n1 | cut -c1-2)" = "ii" ]; then
             echo  "package is already_installed: $1"
        else
            echo  "installing package : $1, please wait.."
            _apt_install_norecommends $1
            sleep 0.5
        fi
    fi
}
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
ThCTLo
  • 29
  • 1
1

If you guys/gals can't get the things in answers here to work and are pulling hair out of your back, try to run the same command using bash -c. Just look at this somnambular delirium. This is what really happening when you run $(sub-command):

First. It can give you completely different output.

$ command -v ls
alias ls='ls --color=auto'
$ bash -c "command -v ls"
/bin/ls

Second. It can give you no output at all.

$ command -v nvm
nvm
$ bash -c "command -v nvm"
$ bash -c "nvm --help"
bash: nvm: command not found
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
user619271
  • 4,276
  • 5
  • 26
  • 32
  • The differences are caused by the difference between interactive and non-interactive mode of the shell. Your ~/.bashrc is read only when the shell is non-login and interactive. The second one looks odd though, because this must be caused by a difference in PATH environment variable, but subshells inherit the environment. – Palec Aug 26 '15 at 10:47
  • In my case `.bashrc` have a `[ -z "$PS1" ] && return` prepended by `# If not running interactively, don't do anything` so I guess that is a reason why even explicit sourcing of bashrc in non-interactive mode doesn't help. The problem can be workarounded by calling a script with a http://ss64.com/bash/source.html dot operator `. ./script.sh` but that is not a thing one would like to remember to type each time. – user619271 Aug 26 '15 at 12:16
  • 1
    Sourcing scripts that are not supposed to be sourced is a bad idea. All I was trying to say is that your answer has little to do with the question being asked and much to do with Bash and its (non-)interactive mode. – Palec Aug 26 '15 at 13:12
  • If it explained what is going on in these cases, it would be a helpful addendum to an answer. – Palec Aug 26 '15 at 16:06
1

In case you want to check if a program exists and is really a program, not a Bash built-in command, then command, type and hash are not appropriate for testing as they all return 0 exit status for built-in commands.

For example, there is the time program which offers more features than the time built-in command. To check if the program exists, I would suggest using which as in the following example:

# First check if the time program exists
timeProg=`which time`
if [ "$timeProg" = "" ]
then
  echo "The time program does not exist on this system."
  exit 1
fi

# Invoke the time program
$timeProg --quiet -o result.txt -f "%S %U + p" du -sk ~
echo "Total CPU time: `dc -f result.txt` seconds"
rm result.txt
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
rpr
  • 138
  • 5
  • This is not poxis. Not work in modern distors debian based. If not exists return "time not found" – abkrim Mar 26 '21 at 16:17
1

The which command might be useful. man which

It returns 0 if the executable is found and returns 1 if it's not found or not executable:

NAME

       which - locate a command

SYNOPSIS

       which [-a] filename ...

DESCRIPTION

       which returns the pathnames of the files which would
       be executed in the current environment, had its
       arguments been given as commands in a strictly
       POSIX-conformant shell. It does this by searching
       the PATH for executable files matching the names
       of the arguments.

OPTIONS

       -a     print all matching pathnames of each argument

EXIT STATUS

       0      if all specified commands are 
              found and executable

       1      if one or more specified commands is nonexistent
              or not executable

       2      if an invalid option is specified

The nice thing about which is that it figures out if the executable is available in the environment that which is run in - it saves a few problems...

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
Adam Davis
  • 87,598
  • 55
  • 254
  • 328
  • Use which if you looking for any executable named foo, but see my answer if you want to check a particular file /path/to/a/named/foo. Also note that which may not be available on some minimal systems, though it should be present on any full fledged installation... – dmckee --- ex-moderator kitten Feb 26 '09 at 22:01
  • 10
    Don't rely in the exit status of which. Many operating systems have a which that doesn't even set an exit status other than 0. – lhunath Mar 24 '09 at 12:46
0

I second the use of "command -v". E.g. like this:

md=$(command -v mkdirhier) ; alias md=${md:=mkdir}  # bash

emacs="$(command -v emacs) -nw" || emacs=nano
alias e=$emacs
[[ -z $(command -v jed) ]] && alias jed=$emacs
0

If there isn't any external type command available (as taken for granted here), we can use POSIX compliant env -i sh -c 'type cmd 1>/dev/null 2>&1':

# Portable version of Bash's type -P cmd (without output on stdout)
typep() {
   command -p env -i PATH="$PATH" sh -c '
      export LC_ALL=C LANG=C
      cmd="$1"
      cmd="`type "$cmd" 2>/dev/null || { echo "error: command $cmd not found; exiting ..." 1>&2; exit 1; }`"
      [ $? != 0 ] && exit 1
      case "$cmd" in
        *\ /*) exit 0;;
            *) printf "%s\n" "error: $cmd" 1>&2; exit 1;;
      esac
   ' _ "$1" || exit 1
}

# Get your standard $PATH value
#PATH="$(command -p getconf PATH)"
typep ls
typep builtin
typep ls-temp

At least on Mac OS X v10.6.8 (Snow Leopard) using Bash 4.2.24(2) command -v ls does not match a moved /bin/ls-temp.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
freno
  • 9
  • 1
0

I had to check if Git was installed as part of deploying our CI server. My final Bash script was as follows (Ubuntu server):

if ! builtin type -p git &>/dev/null; then
  sudo apt-get -y install git-core
fi
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
Greg K
  • 9,582
  • 10
  • 40
  • 57
  • 3
    The conditional is rather useless, modulo the startup time to run apt-get, as apt-get will be satisfied and exit if git-core is already installed. – tripleee Sep 03 '11 at 08:52
  • 4
    Its startup time is non-negligible, but the more important motivation is `sudo`: without the conditional, it would always stop and ask for password (unless you did a sudo recently). BTW, it may be useful to do `sudo -p "Type your password to install missing git-core: "` so the prompt doesn't come out of the blue. – Beni Cherniavsky-Paskin Nov 15 '12 at 12:33
0

To mimic Bash's type -P cmd, we can use the POSIX compliant env -i type cmd 1>/dev/null 2>&1.

man env
# "The option '-i' causes env to completely ignore the environment it inherits."
# In other words, there are no aliases or functions to be looked up by the type command.

ls() { echo 'Hello, world!'; }

ls
type ls
env -i type ls

cmd=ls
cmd=lsx
env -i type $cmd 1>/dev/null 2>&1 || { echo "$cmd not found"; exit 1; }
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
tim
  • 41
  • 1
  • 7
    Why is this being upvoted? On which systems does this actually work for you? `type` seems to be a `builtin` in most shells so this can't work because `env` uses `execvp` to run `command` so `command` cannot be a `builtin` (and the `builtin` will always be run within the same environment). This fails for me in `bash`, `ksh93`, `zsh`, `busybox [a]sh` and `dash` all of which provide `type` as a shell builtin. – Adrian Frühwirth Apr 17 '14 at 09:00
0

zsh only, but very useful for zsh scripting (e.g. when writing completion scripts):

The zsh/parameter module gives access to, among other things, the internal commands hash table. From man zshmodules:

THE ZSH/PARAMETER MODULE
       The zsh/parameter module gives access to some of the internal hash  ta‐
       bles used by the shell by defining some special parameters.


[...]

       commands
              This  array gives access to the command hash table. The keys are
              the names of external commands, the values are the pathnames  of
              the  files  that would be executed when the command would be in‐
              voked. Setting a key in this array defines a new entry  in  this
              table  in the same way as with the hash builtin. Unsetting a key
              as in `unset "commands[foo]"' removes the entry  for  the  given
              key from the command hash table.

Although it is a loadable module, it seems to be loaded by default, as long as zsh is not used with --emulate.

example:

martin@martin ~ % echo $commands[zsh]
/usr/bin/zsh

To quickly check whether a certain command is available, just check if the key exists in the hash:

if (( ${+commands[zsh]} ))
then
  echo "zsh is available"
fi

Note though that the hash will contain any files in $PATH folders, regardless of whether they are executable or not. To be absolutely sure, you have to spend a stat call on that:

if (( ${+commands[zsh]} )) && [[ -x $commands[zsh] ]]
then
  echo "zsh is available"
fi
Martin von Wittich
  • 238
  • 1
  • 6
  • 16
0

The hash-variant has one pitfall: On the command line you can for example type in

one_folder/process

to have process executed. For this the parent folder of one_folder must be in $PATH. But when you try to hash this command, it will always succeed:

hash one_folder/process; echo $? # will always output '0'
anycast.cw
  • 25
  • 1
  • 4
    "For this the parent folder of one_folder must be in `$PATH`"—This is completely inaccurate. Try it. For this to work, one_folder must be in the *current directory*. – Wildcard Jan 01 '16 at 02:55
-1

I use this, because it's very easy:

if [ `LANG=C type example 2>/dev/null|wc -l` = 1 ];then echo exists;else echo "not exists";fi

or

if [ `LANG=C type example 2>/dev/null|wc -l` = 1 ];then
echo exists
else echo "not exists"
fi

It uses shell builtins and programs' echo status to standard output and nothing to standard error. On the other hand, if a command is not found, it echos status only to standard error.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
A.N
  • 61
  • 7
-1

Script

#!/bin/bash

# Commands found in the hash table are checked for existence before being
# executed and non-existence forces a normal PATH search.
shopt -s checkhash

function exists() {
 local mycomm=$1; shift || return 1

 hash $mycomm 2>/dev/null || \
 printf "\xe2\x9c\x98 [ABRT]: $mycomm: command does not exist\n"; return 1;
}
readonly -f exists

exists notacmd
exists bash
hash
bash -c 'printf "Fin.\n"'

Result

✘ [ABRT]: notacmd: command does not exist
hits    command
   0    /usr/bin/bash
Fin.
ecwpz91
  • 999
  • 11
  • 7
-1

Assuming you are already following safe shell practices:

set -eu -o pipefail
shopt -s failglob

./dummy --version 2>&1 >/dev/null

This assumes the command can be invoked in such a way that it does (almost) nothing, like reporting its version or showing help.

If the dummy command is not found, Bash exits with the following error...

./my-script: line 8: dummy: command not found

This is more useful and less verbose than the other command -v (and similar) answers because the error message is auto generated and also contains a relevant line number.

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
Autodidact
  • 25,926
  • 15
  • 63
  • 81
  • This answer is very unclear to those who are not good with shell as it does not state how this code is supposed to be used and it differs from many other answers in that the failed branch of the test for `dummy`'s existence is out of hands of the script's author. Also, it lacks explanation of how it works and that it changes settings of the execution environment. – Palec Oct 28 '19 at 06:58
  • This is a Bash question, but it might be worth mentioning that the non-POSIX `shopt` call can be replaced with POSIX `set -f`, which is shorter and portable. The [pipefail option is not supported in POSIX](https://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#set), though, and there is no alternative, AFAIK. – Palec Oct 28 '19 at 06:59
  • @Palec I am not sure how this is difficult. It's actually simpler as it relies on the shell to let the user know that the command can not be found and exits with an error, as requested by the OP. Let me know what I missed :) – Adrien Apr 07 '20 at 09:36
-1

Late answer but this is what I ended up doing.

I just check if the command I execute returns an error code. If it returns 0 it means program is installed. Moreover you can use this to check the output of a script. Take for instance this script.

foo.sh

#!/bin/bash
echo "hello world"
exit 1 # throw some error code

Examples:

# outputs something bad... and exits
bash foo.sh $? -eq 0 || echo "something bad happened. not installed" ; exit 1

# does NOT outputs nothing nor exits because dotnet is installed on my machine
dotnet --version $? -eq 0 || echo "something bad happened. not installed" ; exit 1

Basically all this is doing is checking the exit code of a command run. the most accepted answer on this question will return true even if the command exit code is not 0.

Tono Nam
  • 29,637
  • 73
  • 252
  • 421
  • I'm not 100% certain if your last statement is correct. The most accepted answer uses the command `command` with the flag `-v` to quickly validate if its argument is a built-in or executable command that is found in `PATH`. So the statement `if ! command -v STRING; then ...; fi` will validate if `STRING` is a valid _command_. – kvantour Oct 20 '20 at 12:11
  • This is a different approach where it checks the exit code of the last command executed. The accepted answer is probably best for most of the cases. This is an alternative if you want to go deeper. – Tono Nam Oct 21 '20 at 14:02
-2
GIT=/usr/bin/git                     # STORE THE RELATIVE PATH
# GIT=$(which git)                   # USE THIS COMMAND TO SEARCH FOR THE RELATIVE PATH

if [[ ! -e $GIT ]]; then             # CHECK IF THE FILE EXISTS
    echo "PROGRAM DOES NOT EXIST."
    exit 1                           # EXIT THE PROGRAM IF IT DOES NOT
fi

# DO SOMETHING ...

exit 0                               # EXIT THE PROGRAM IF IT DOES
  • 2
    1) This is an absolute path. 2) You only check whether the program exists *in a particular location*, rather than being callable. I could have something in `/usr/local/bin` instead and your code would exit. – Arya McCarthy Jun 19 '17 at 15:06
-2
checkexists() {
    while [ -n "$1" ]; do
        [ -n "$(which "$1")" ] || echo "$1": command not found
        shift
    done
}
-3

I couldn't get one of the solutions to work, but after editing it a little I came up with this. Which works for me:

dpkg --get-selections | grep -q linux-headers-$(uname -r)

if [ $? -eq 1 ]; then
        apt-get install linux-headers-$(uname -r)
fi
Bono
  • 4,477
  • 6
  • 43
  • 76
Jan
  • 7
-4

I would just try and call the program with for example --version or --help and check if the command succeeded or failed

Used with set -e, the script will exit if the program is not found, and you will get a meaningful error message:

#!/bin/bash
set -e
git --version >> /dev/null
Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
fjk
  • 39
  • 3
-4

Use:

if [[ `command --help` ]]; then
  echo "This command exists"
else
  echo "This command does not exist";
fi

Put in a working switch, such as "--help" or "-v" in the if check: if [[ command --help ]]; then

Peter Mortensen
  • 28,342
  • 21
  • 95
  • 123
Farhad Sakhaei
  • 644
  • 7
  • 23